<script setup lang="ts">
import type { PagePermission } from '~/models/role'
import Error from '~/components/pub/my-ui/error/error.vue'
import { PAGE_PERMISSIONS } from '~/lib/page-permission'
import EncounterProcess from '~/components/content/encounter/process.vue'

definePageMeta({
  middleware: ['rbac'],
  roles: ['doctor', 'nurse', 'admisi', 'pharmacy', 'billing', 'management'],
  title: 'Tambah Kunjungan',
  contentFrame: 'cf-full-width',
})

const route = useRoute()

useHead({
  title: () => `${route.meta.title}`,
})

const roleAccess: PagePermission = PAGE_PERMISSIONS['/rehab/encounter']

const { checkRole, hasCreateAccess, getPagePermissions } = useRBAC()

// Check if user has access to this page
const hasAccess = checkRole(roleAccess)
// if (!hasAccess) {
//   throw createError({
//     statusCode: 403,
//     statusMessage: 'Access denied',
//   })
// }

// Define permission-based computed properties
const pagePermission = getPagePermissions(roleAccess)
</script>

<template>
  <div v-if="pagePermission.canRead">
    <EncounterProcess class-code="ambulatory" sub-class-code="rehab" />
  </div>
  <Error v-else :status-code="403" />
</template>
